package cn.com.ty.lift.business.maintenance.controller;

import cn.com.ty.lift.business.maintenance.dao.entity.model.request.PropertyMaintenanceVO;
import cn.com.ty.lift.business.maintenance.dao.entity.model.response.PropertyMtResponse;
import cn.com.ty.lift.business.maintenance.dao.mapper.PropertyMaintenanceMapper;
import cn.com.ty.lift.common.constants.ApiConstants;
import cn.com.xwy.boot.web.dto.RestResponse;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@AllArgsConstructor
@RequestMapping("property")
public class PropertyMaintenanceController {
    private final PropertyMaintenanceMapper propertyMaintenanceMapper;

    @PostMapping("maintenance")
    public RestResponse maintenance(@RequestBody PropertyMaintenanceVO propertyMaintenanceVO) {
        Page<PropertyMtResponse> propertyMtResponsePage = new Page<>(propertyMaintenanceVO.getPageNum(), propertyMaintenanceVO.getPageSize());
        //todo
        return RestResponse.success("待实现");
    }

    public Page<PropertyMtResponse> propertyMtResponsePage(Page<PropertyMtResponse> propertyMtResponsePage, PropertyMaintenanceVO propertyMaintenanceVO) {
        Page<PropertyMtResponse> page;
        Integer maintenanceStatus = ApiConstants.Maintenance.WAITING_MAINTENANCE;
        switch (propertyMaintenanceVO.getType()) {
            case 1:
                break;
            case 2:
                maintenanceStatus = ApiConstants.Maintenance.MAINTENANCE_DOING;
                break;
            case 3:
                maintenanceStatus = ApiConstants.Maintenance.COMPLETE;
                break;
            case 4:
                maintenanceStatus = ApiConstants.Maintenance.OVERDUE;
                break;
            case 5:
                //todo
                page = new Page<>();
                break;
            default:
                page = new Page<>();
        }
        page = propertyMaintenanceMapper
                .queryMaintenancePlanEveryDay(
                        propertyMtResponsePage,
                        maintenanceStatus,
                        propertyMaintenanceVO.getPlanDate(),
                        propertyMaintenanceVO.getUserId());
        return page;
    }
}
